package auction;

import java.util.Collection;
import java.util.Iterator;

import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * Bean implementation class for Enterprise Bean: UserFacade
 */
public class UserFacadeBean implements javax.ejb.SessionBean {
	private javax.ejb.SessionContext mySessionCtx;
	/**
	 * getSessionContext
	 */
	public javax.ejb.SessionContext getSessionContext() {
		return mySessionCtx;
	}
	/**
	 * setSessionContext
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx) {
		mySessionCtx = ctx;
	}
	/**
	 * ejbCreate
	 */
	public void ejbCreate() throws javax.ejb.CreateException {
	}
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() {
	}

	private InitialContext initContext;

	private RegistrationLocalHome getRegistrationLocalHome() throws NamingException {
		if (initContext == null) {
			initContext= new InitialContext();
		}
		return (RegistrationLocalHome)initContext.lookup("java:comp/env/ejb/Registration");
	}

	private AddressLocalHome getAddressLocalHome() throws NamingException {
		if (initContext == null) {
			initContext= new InitialContext();
		}
		return (AddressLocalHome)initContext.lookup("java:comp/env/ejb/Address");
	}

	public RegistrationData findById(Integer userid) {
		RegistrationData data = null;
		try {
			data = getRegistrationLocalHome().findByPrimaryKey(new RegistrationKey(userid)).getRegistrationData();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return data;
	}

	public RegistrationData[] findByName(String name) {
		RegistrationData[] data = null;
		try {
			Collection col = getRegistrationLocalHome().findByName(name);
			data = new RegistrationData[col.size()];
			Iterator it = col.iterator();
			for (int i = 0; it.hasNext(); i++) {
				data[i] = ((RegistrationLocal)it.next()).getRegistrationData();
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return data;
	}

	public void create(RegistrationData data) {
		try {
			getRegistrationLocalHome().create(data.getUserid()).setRegistrationData(data);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void update(RegistrationData data) {
		try {
			getRegistrationLocalHome().findByPrimaryKey(new RegistrationKey(data.getUserid())).setRegistrationData(data);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}