<%@ page session="false" buffer="none" %>
<%-- Licensed Materials - Property of IBM, 5724-E76, (C) Copyright IBM Corp. 2001, 2004 - All Rights reserved. --%>

<%@ page import="com.ibm.wps.command.portalsettings.*, com.ibm.wps.command.*" %>
<%@ taglib uri="/WEB-INF/tld/engine.tld" prefix="wps" %>

<card id="initLogin" title="<wps:text key="link.login" bundle="nls.engine"/>">
    <wps:if resumeLevel="0">
        <%-- user is not allowed to resume. Do not generate the checkbox --%>
        <%-- 3. LogIn --%>
        <wps:popupMenuItem item="3">
            <wps:popupMenuParam param="2">
                <go href="<wps:url command="LoginUser"/>" method="post">
                    <postfield name="userid" value="$userid"/>
                    <postfield name="password" value="$password"/>
                </go>
            </wps:popupMenuParam>
        </wps:popupMenuItem>
        
        <%-- map accept key --%>
        <do type="accept" label="<wps:text key="link.next" bundle="nls.engine"/>">
            <go href="<wps:url command="LoginUser"/>" method="post">
                <postfield name="userid" value="$userid"/>
                <postfield name="password" value="$password"/>
            </go>
        </do>
            
    </wps:if>
    <wps:if resumeLevel="1,2" resumeOption="yes">
        <%-- user is allowed to resume the prior session at their option --%>
        <%-- 3. LogIn --%>
        <wps:popupMenuItem item="3">
            <wps:popupMenuParam param="2">
                <go href="<wps:url command="LoginUser"/>" method="post">
                    <postfield name="userid" value="$userid"/>
                    <postfield name="password" value="$password"/>
                    <postfield name="resumeSession" value="true"/>
                </go>
            </wps:popupMenuParam>
        </wps:popupMenuItem>
        
        <%-- map accept key --%>
        <do type="accept" label="<wps:text key="link.next" bundle="nls.engine"/>">
            <go href="<wps:url command="LoginUser"/>" method="post">
                <postfield name="userid" value="$userid"/>
                <postfield name="password" value="$password"/>
                <postfield name="resumeSession" value="$resumeSession"/>
            </go>
        </do>
            
    </wps:if>
    <wps:if resumeLevel="1,2" resumeOption="no">
        <%-- user resumes the prior session --%>
        <%-- 3. LogIn --%>
        <wps:popupMenuItem item="3">
            <wps:popupMenuParam param="2">
                <go href="<wps:url command="LoginUser"/>" method="post">
                    <postfield name="userid" value="$userid"/>
                    <postfield name="password" value="$password"/>
                    <postfield name="resumeSession" value="true"/>
                </go>
            </wps:popupMenuParam>
        </wps:popupMenuItem>
        
        <%-- map accept key --%>
        <do type="accept" label="<wps:text key="link.next" bundle="nls.engine"/>">
            <go href="<wps:url command="LoginUser"/>" method="post">
                <postfield name="userid" value="$userid"/>
                <postfield name="password" value="$password"/>
            </go>
        </do>
            
    </wps:if>
    
    <wps:popupMenu />
    

  <p><wps:problem bundle="nls.problem_short"/></p>
  <p>
     <strong>
      <wps:text key="userid" bundle="nls.field"/><br/>
     </strong>
      <input name="userid" title="<wps:text key="userid" bundle="nls.field"/>" size="8" maxlength="16"/><br/>
     <strong>
      <wps:text key="password" bundle="nls.field"/><br/>
     </strong>
      <input name="password" title="<wps:text key="password" bundle="nls.field"/>" size="8" maxlength="16" type="password"/><br/>

     <wps:if resumeLevel="1,2" resumeOption="yes">
        <strong>
            <wps:text key="resume.chtml" bundle="nls.field" /><br/>
        </strong>
        <%--<input name="resumeSession" title="<wps:text key="resume.chtml" bundle="nls.field" />" type="checkbox"/><br/>--%>

        <select name="resumeSession" multiple="false" >
            <option value="true"><wps:text key="c2a.yes" bundle="nls.pbruntime" /></option>
            <option value="false"><wps:text key="c2a.no" bundle="nls.pbruntime" /></option>
        </select>
     </wps:if>

  </p>
</card>

