/*==================================================================
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corp. 2002.  All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 *
 * DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
 * sample code created by IBM Corporation.  This sample code is
 * not part of any standard or IBM product and is provided to you
 * solely for the purpose of assisting you in the development of
 * your applications.  The code is provided "AS IS", without
 * warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have
 * been advised of the possibility of such damages.
 *===============================================================*/
package com.ibm.portal.struts.example.fileupload;

import java.util.Iterator;

import com.ibm.wps.portlet.menu.MenuNode;
import com.ibm.wps.portlet.menu.MenuTree;
import com.ibm.wps.portlet.menu.MenuContext;
import com.ibm.wps.portlet.menu.MenuTreeException;

public class StrutsMenuTree implements MenuTree
{

   private StrutsMenuNode m_strutsMenuNode;

   /**
    * Constructor for the StrutsMenuTree
    * 
    * @param menuContext the menu context
    */   
   public StrutsMenuTree( MenuContext menuContext)
   {
      m_strutsMenuNode = new StrutsMenuNode( menuContext.getPortletRequest(),
                                             menuContext.getPortletResponse() );
   }

   /**
    * get the root of the tree.
    * 
    * @return returns the menu node
    */   
   public MenuNode getRoot() throws MenuTreeException
   {
      return m_strutsMenuNode;
   }

   /**
    * return true if this node has children
    * 
    * @param menuNode the menu node to check
    */
   public boolean hasChildren(MenuNode menuNode )
   {
      return false;
   }

   /**
    * Get the children of the menu node
    * 
    * @param menuNode the menu node to check
    * @return the iterator for the children
    */
   public Iterator getChildren(MenuNode menuNode ) throws MenuTreeException
   {
      return null;
   }
   
}
