package com.ibm.etools.portal.portletexamples.bookmark.legacy;

import java.io.*;

import org.apache.jetspeed.portlet.*;
import org.apache.jetspeed.portlet.event.*;

public class BookmarkPortlet extends PortletAdapter implements ActionListener {

	public void init(PortletConfig portletConfig) throws UnavailableException {
		super.init(portletConfig);
	}

	public void doView(PortletRequest request, PortletResponse response)
		throws PortletException, IOException {

		String VIEW_JSP = this.getPortletConfig().getInitParameter("jspView");
		getPortletConfig().getContext().include(VIEW_JSP, request, response);
	}

	public void doEdit(PortletRequest request, PortletResponse response)
		throws PortletException, IOException {

		PortletURI cancelURI = response.createReturnURI();
		request.setAttribute("cancelURI", cancelURI.toString());

		PortletURI addURI = response.createReturnURI();
		addURI.addAction("add");
		request.setAttribute("addURI", addURI.toString());

		String EDIT_JSP = this.getPortletConfig().getInitParameter("jspEdit");
		getPortletConfig().getContext().include(EDIT_JSP, request, response);

	}

	public void actionPerformed(ActionEvent event) throws PortletException {

		PortletRequest request = event.getRequest();
		String action = event.getActionString();
		PortletLog log = getPortletLog();

		if (action != null) {
			try {
				if (action.equals("removeURI")) {
					String removeName = request.getParameter("remove");
					PortletData portData = request.getData();
					portData.removeAttribute(removeName);
					portData.store();
				}
			} catch (AccessDeniedException ade) {
				log.error(
					"An AccessDeniedException was thrown when trying to remove a bookmark.");
			} catch (IOException ioe) {
				log.error("An IO error occured when trying to remove a bookmark.");
			}
			try {
				if (action.equals("add")) {
					PortletData portData = request.getData();
					String name = request.getParameter("name");
					String value = request.getParameter("value");
					portData.setAttribute(name, value);
					portData.store();
				}
			} catch (AccessDeniedException ade) {
				log.error(
					"An AccessDeniedException was thrown when trying to add a bookmark.");
			} catch (IOException ioe) {
				log.error("An IO error occured when trying to add a bookmark.");
			}
		}
	}
}
