package com.ibm.etools.portal.portletexamples.content.jsr;

import java.util.*;
import javax.portlet.*;

public class ContentAccessServicePortletPreferencesValidator implements PreferencesValidator {

	/**
	 * Validate portlet preferences
	 * 
	 * @see javax.portlet.PreferencesValidator#validate(javax.portlet.PortletPreferences)
	 */
	public void validate(PortletPreferences preferences) throws ValidatorException 	{
		Collection failedKeys = new ArrayList();
		for( Enumeration names=preferences.getNames(); names.hasMoreElements(); ) {
			String name = names.nextElement().toString();
			String value = preferences.getValue(name, "");
			//validates that the preferences do not start or end with white space
			//validates that the preferences start with http: or https:
			if( !value.equalsIgnoreCase(value.trim()) || !(value.startsWith("http:")||value.startsWith("https:")) ) {
				failedKeys.add(name);
			}
		}
		if ( !failedKeys.isEmpty() ) {
			throw new ValidatorException("One or more preferences do not comply with the validation criteria",failedKeys);
		}
	}
}
