/* @copyright module */
/*                                                                            */
/*  DISCLAIMER OF WARRANTIES:                                                 */
/*  -------------------------                                                 */
/*  The following [enclosed] code is sample code created by IBM Corporation.  */
/*  This sample code is provided to you solely for the purpose of assisting   */
/*  you in the development of your applications.                              */
/*  The code is provided "AS IS", without warranty of any kind. IBM shall     */
/*  not be liable for any damages arising out of your use of the sample code, */
/*  even if they have been advised of the possibility of such damages.        */
package com.ibm.etools.portal.portletexamples.cooperative.jsr; 

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

/*
 * This class encapsulates all the data used to feed the shipping portlets. 
 * In the real world, this would be stored in a database.
 */
public class ShippingDB {

    public static final String JANUARY = "January";
    public static final String FEBRUARY = "February";
    public static final String MARCH = "March";
    public static final String APRIL = "April";
    public static final String MAY = "May";
    public static final String JUNE = "June";
    public static final String JULY = "July";
    public static final String AUGUST = "August";
    public static final String SEPTEMBER = "September";
    public static final String OCTOBER = "October";
    public static final String NOVEMBER = "November";
    public static final String DECEMBER = "December";

    private static final String months[] = { JANUARY, FEBRUARY, MARCH, APRIL, MAY, JUNE, JULY, AUGUST, SEPTEMBER, OCTOBER, NOVEMBER, DECEMBER };

    //HARDWIRED ORDER DATA FOR EACH MONTH
    private static String monthlyOrders [][][] ={ 
					       //JANUARY
                                               {
					           //orderId, customerId, status
                                                   { "012001000000", "5728883", "DELAYED"}, //0
                                                   { "012001000001", "1299877", "COMPLETE"}, //7
                                                   { "012001000002", "1299877", "COMPLETE"}, //7
                                                   { "012001000003", "5827744", "COMPLETE"}, //9
                                                   { "012001000004", "8266472", "COMPLETE"}, //10
                                                   { "012001000005", "3764002", "ON_TIME"}, //5
                                               },
                                               {
					       //FEBRUARY
                                                   { "022001000011", "5728883", "ON_TIME"}, //1
                                                   { "022001000012", "5728883", "ON_TIME"}, //0
                                                   { "022001000013", "2880993", "COMPLETE"}, //2
                                                   { "022001000014", "8927723", "COMPLETE"}, //6
                                                   { "022001000015", "3764002", "ON_TIME"}, //5
                                                   { "022001000016", "4878733", "ON_TIME"}, //4
                                                   { "022001000017", "8288473", "ON_TIME"}, //3
                                                   { "022001000018", "8266472", "DELAYED"}, //1
                                               },
					       //MARCH
                                               {
                                                   { "032001000000", "8266472", "DELAYED"}, //1
                                                   { "032001000001", "3542877", "ON_TIME"}, //1
                                                   { "032001000002", "1299877", "COMPLETE"}, //7
                                                   { "032001000003", "2880993", "ON_TIME"}, //2
                                               },
					       //APRIL
                                               {
                                                   { "042001000001", "3542877", "COMPLETE"}, //1
                                                   { "042001000002", "5728883", "COMPLETE"}, //0
                                                   { "042001000003", "8266472", "COMPLETE"}, //10
                                                   { "042001000004", "1299877", "ON_TIME"}, //7
                                                   { "042001000005", "1299877", "DELAYED"}, //7
                                               },
					       //MAY
                                               {
                                                   { "052001000000", "5728883", "DELAYED"}, //0
                                                   { "052001000001", "3542877", "ON_TIME"}, //1
                                                   { "052001000002", "8266472", "COMPLETE"}, //10
                                                   { "052001000003", "2867377", "ON_TIME"}, //11
                                               },
					       //JUNE
                                               {
                                                   { "062001000001", "3542877", "COMPLETE"}, //1
                                                   { "062001000002", "5728883", "ON_TIME"}, //0
                                                   { "062001000003", "5827744", "COMPLETE"}, //9
                                                   { "062001000004", "8288473", "ON_TIME"}, //3
                                                   { "062001000005", "3542877", "DELAYED"}, //1
                                               },
					       //JULY
                                               {
                                                   { "072001000000", "3542877", "DELAYED"}, //1
                                                   { "072001000001", "3542877", "ON_TIME"}, //1
                                                   { "072001000002", "5728883", "ON_TIME"}, //0
                                                   { "072001000003", "8288473", "ON_TIME"}, //3
                                               },
					       //AUGUST
                                               {
                                                   { "082001000001", "3542877", "COMPLETE"}, //1
                                                   { "082001000002", "8288473", "DELAYED"}, //1
                                               },
					       //SEPTEMBER
                                               {
                                                   { "092001000000", "5728883", "DELAYED"}, //1
                                                   { "092001000001", "3542877", "ON_TIME"}, //1
                                                   { "092001000002", "5728883", "COMPLETE"}, //0
                                                   { "092001000003", "2880993", "ON_TIME"}, //2
                                                   { "092001000004", "5827744", "ON_TIME"}, //9
                                                   { "092001000005", "3764002", "ON_TIME"}, //5
                                                   { "092001000006", "4878733", "ON_TIME"}, //4
                                               },
					       //OCTOBER
                                               {
                                                   { "102001000001", "3542877", "ON_TIME"}, //1
                                                   { "102001000002", "3045388", "COMPLETE"}, //8
                                                   { "102001000003", "8266472", "COMPLETE"}, //10
                                                   { "102001000004", "2867377", "ON_TIME"}, //11
                                                   { "102001000005", "2867377", "DELAYED"}, //11
                                               },
					       //NOVEMBER
                                               {
                                                   { "112001000000", "2867377", "DELAYED"}, //11
                                                   { "112001000001", "3542877", "ON_TIME"}, //1
                                                   { "112001000002", "3045388", "ON_TIME"}, //8
                                               },
					       //DECEMBER
                                               {
                                                   { "122001000000", "1299877", "DELAYED"}, //7
                                                   { "122001000001", "3542877", "ON_TIME"}, //1
                                                   { "122001000002", "1299877", "ON_TIME"}, //7
                                                   { "122001000003", "1299877", "ON_TIME"}, //7
                                                   { "122001000004", "5827744", "COMPLETE"}, //9
                                                   { "122001000005", "3764002", "ON_TIME"}, //5
                                                   { "122001000006", "4878733", "COMPLETE"}, //4
                                                   { "122001000007", "3045388", "ON_TIME"}, //8
                                                   { "122001000008", "8288473", "COMPLETE"}, //3
                                                   { "122001000009", "2867377", "ON_TIME"}, //11
                                                   { "122001000010", "8288473", "ON_TIME"}, //3
                                                   { "122001000011", "3045388", "DELAYED"}, //8
                                               }
					   };

   private static int numMonthlyOrders[] = {6, 8, 4, 5, 4, 5, 4, 2, 7, 5, 3, 11};
   private static HashMap monthlyOrdersMap = new HashMap();

    private static String customerDetails [][] = {
                                       //custId, name,       address,                                        contactInfo
				       //0
                                      {"5728883", "Bob Smith","Celeric Corp., 201, West Av, Pittsburgh, PA","bob_smith@celeric.com"},
				       //1
                                      {"3542877", "John Segal","MoreProfit Widgets Corp., 101, Mayfield Av, Atlanta, GA","j_segal@moreprofit.com"},
				       //2
                                      {"2880993", "Jill Smith","BellVue Tech. Univ., 1B, ScenicView Blvd., Pittsburgh, PA","jill_smith@btu.edu"},
				       //3
                                      {"8288473", "Alex Brown","IntelliBro, 1C, 1st Av, Raleigh , NC","alex_brown@intellibro.com"},
				       //4
                                      {"4878733", "Steve Kaminski","SMS Defense Corp., 1 Mayflower Av, Fairfax, VA","stevek@sdc.com"},

				       //5
                                      {"3764002", "Joel Straw","WYM Financial Services, 1 North Av, New York, NY","jstraw@wym.com"},
				       //6
                                      {"8927723", "Nancy Noel","BOM Inc., 5788 Los Gatos Blvd., Santa Clara, CA", "cfo@bom.com"},
				       //7
                                      {"1299877", "Bill C. Eastwood","GT Times Inc., Broad St., Mt. Kisco, NY", "bill@gttimes.com"},
				       //8
                                      {"3045388", "Mary Smith","TrueBlue Inc., Green St., Grand Lake, MD", "msmith@trueblue.com"},
				       //9
                                      {"5827744", "Ken Lawyer","RON Corp, Amarillo, TX", "lawyer@ron.com"},
				       //10
                                      {"8266472", "Amir R. Chowdhury","Systems and Solutions Inc., Corporate Blvd., Buffalo, NY", "arc@ssi.com"},
				       //11
                                      {"2867377", "Sam Choudhary","NextGeneration Web Technologies, Governer Davis Blvd., Chapel Hill, NC", "samc@ngw.com"}

                                      };

    private static HashMap customerDetailsMap = new HashMap();
    private static HashMap customerDetailsByNameMap = new HashMap();
    private static int numCustomers = 12;
   private static String parts[] = {"AB-299011", "AC-288399", "BB-128933", "GR-001834", "SS-019928", "TR-123992", "UV-442892"};

   private static String orderDetails [][] = {
                                           //orderId, partNo,      units,   status,       trackingId
                                           { "012001000000", parts[4], "4000", "DELAYED" , "17257332"}, //7
                                           { "012001000001", parts[0], "1000", "COMPLETE" , "19987333"}, //7
                                           { "012001000002", parts[1], "10000", "COMPLETE" , "18678334"}, //7
                                           { "012001000003", parts[1], "2000", "COMPLETE" , "18277893"}, //9
                                           { "012001000004", parts[5], "3000", "COMPLETE" , "16892883"}, //10
                                           { "012001000005", parts[0], "100", "ON_TIME" , "15787333"}, //5

                                           { "022001000011", parts[0], "1000", "ON_TIME" , "18277333"}, //1
                                           { "022001000012", parts[1], "10000", "ON_TIME", "22893727"}, //3
                                           { "022001000013", parts[0], "5000", "COMPLETE", "18399487"}, //0
                                           { "022001000014", parts[5], "50000", "COMPLETE", "21948882"}, //4
                                           { "022001000015", parts[4], "10000","ON_TIME" , "19377832"}, //2
                                           { "022001000016", parts[3], "10000","ON_TIME" , "20039882"}, //6
                                           { "022001000017", parts[6], "5000", "ON_TIME", "20199727"}, //5
                                           { "022001000018", parts[5], "1000", "DELAYED", "21354220"}, //5

                                           { "032001000000", parts[5], "1000", "DELAYED", "23217832"}, //1
                                           { "032001000001", parts[1], "2000", "ON_TIME", "28489292"}, //1
                                           { "032001000002", parts[2], "500", "COMPLETE", "23788288"}, //7
                                           { "032001000003", parts[4], "5000", "ON_TIME", "23789993"}, //2

                                           { "042001000001", parts[4], "6000", "COMPLETE", "28789933"}, //1
                                           { "042001000002", parts[1], "500", "COMPLETE", "37288933"}, //0
                                           { "042001000003", parts[0], "11000", "COMPLETE", "32832646"}, //10
                                           { "042001000004", parts[4], "2000", "ON_TIME", "31884722"}, //7
                                           { "042001000005", parts[4], "4000", "DELAYED", "32561287"}, //7
                                           { "052001000000", parts[4], "5000", "DELAYED", "31994821"}, //1
                                           { "052001000001", parts[4], "12000", "ON_TIME", "32994822"}, //1
                                           { "052001000002", parts[6], "1000", "COMPLETE", "42884774"}, //10
                                           { "052001000003", parts[0], "500", "ON_TIME", "43277843"}, //11

                                           { "062001000001", parts[0], "600", "COMPLETE", "42997722"}, //1
                                           { "062001000002", parts[6], "3000", "ON_TIME", "46727722"}, //0
                                           { "062001000003", parts[6], "2000", "COMPLETE", "42276933"}, //9
                                           { "062001000004", parts[5], "500", "ON_TIME", "41083622"}, //3
                                           { "062001000005", parts[5], "6000", "DELAYED", "40353783"}, //3
                                           { "072001000000", parts[5], "7000", "DELAYED", "50090225"}, //1
                                           { "072001000001", parts[5], "1000", "ON_TIME", "41857372"}, //1
                                           { "072001000002", parts[4], "1000", "ON_TIME", "52882912"}, //0
                                           { "072001000003", parts[3], "2000", "ON_TIME", "53882244"}, //3

                                           { "082001000001", parts[3], "2000", "COMPLETE", "52657382"}, //1
                                           { "082001000002", parts[3], "8000", "DELAYED", "53729714"}, //1
                                           { "092001000000", parts[3], "9000", "DELAYED", "52513443"}, //1
                                           { "092001000001", parts[3], "3000", "ON_TIME", "53288229"}, //1
                                           { "092001000002", parts[2], "4000", "COMPLETE", "52789422"}, //0
                                           { "092001000003", parts[3], "2000", "ON_TIME", "52882742"}, //2
                                           { "092001000004", parts[4], "200", "ON_TIME", "55299333"}, //9
                                           { "092001000005", parts[5], "20", "ON_TIME", "56729902"}, //5
                                           { "092001000006", parts[6], "6600", "ON_TIME", "51043882"}, //4

                                           { "102001000001", parts[2], "7000", "ON_TIME", "52787953"}, //1
                                           { "102001000002", parts[3], "6500", "COMPLETE", "57920822"}, //8
                                           { "102001000003", parts[4], "800", "COMPLETE", "57028837"}, //10
                                           { "102001000004", parts[3], "1200", "ON_TIME", "59028822"}, //1
                                           { "102001000005", parts[3], "9000", "DELAYED", "60001575"}, //1
                                           { "112001000000", parts[0], "10000", "DELAYED", "62134876"}, //1
                                           { "112001000001", parts[0], "200", "ON_TIME", "62178393"}, //1
                                           { "112001000002", parts[2], "100", "ON_TIME", "63929883"}, //8

                                           { "122001000000", parts[2], "10000", "DELAYED", "63453021"}, //1
                                           { "122001000001", parts[2], "1000", "ON_TIME", "63490203"}, //1
                                           { "122001000002", parts[2], "20000", "ON_TIME", "62599339"}, //7
                                           { "122001000003", parts[2], "30000", "ON_TIME", "64299483"}, //7
                                           { "122001000004", parts[2], "20000", "ON_TIME", "64529484"}, //9
                                           { "122001000005", parts[2], "1000", "ON_TIME", "62994833"}, //5
                                           { "122001000006", parts[2], "200000", "COMPLETE", "66729938"}, //4
                                           { "122001000007", parts[2], "30000", "ON_TIME", "66290488"}, //8
                                           { "122001000008", parts[2], "4000", "COMPLETE", "65729948"}, //3
                                           { "122001000009", parts[2], "50000", "ON_TIME", "67983003"}, //11
                                           { "122001000010", parts[2], "100000", "ON_TIME", "68120039"}, //3
                                           { "122001000011", parts[2], "80000", "DELAYED", "70000000"}, //3
                                          };

    private static String trackingDetails [][] = {
                                      //trackingId, status, customerName, destination
                                      {"17257332", "TRANSIT", customerDetails[0][1] , customerDetails[0][2] },
                                      {"19987333", "DELIVERED", customerDetails[7][1] , customerDetails[7][2] },
                                      {"18678334", "DELIVERED", customerDetails[7][1] , customerDetails[7][2] },
                                      {"18277893", "DELIVERED", customerDetails[9][1] , customerDetails[9][2] },
                                      {"16892883", "DELIVERED", customerDetails[10][1] , customerDetails[10][2] },
                                      {"15787333", "DELIVERED", customerDetails[5][1] , customerDetails[5][2] },
                                      {"18277333", "TRANSIT", customerDetails[0][1] , customerDetails[0][2] },
                                      {"22893727", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"18399487", "DELIVERED", customerDetails[2][1] , customerDetails[2][2] },
                                      {"21948882", "DELIVERED", customerDetails[3][1] , customerDetails[3][2] },

                                      {"19377832", "TRANSIT", customerDetails[5][1] , customerDetails[5][2] },
                                      {"20039882", "TRANSIT", customerDetails[5][1] , customerDetails[5][2] },
                                      {"20199727", "TRANSIT", customerDetails[6][1] , customerDetails[6][2] },
                                      {"21354220", "TRANSIT", customerDetails[10][1] , customerDetails[10][2] },
                                      {"28489292", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"23217832", "TRANSIT", customerDetails[10][1] , customerDetails[10][2] },
                                      {"23788288", "DELIVERED", customerDetails[7][1] , customerDetails[7][2] },
                                      {"23789993", "DELIVERED", customerDetails[2][1] , customerDetails[2][2] },
                                      {"28789933", "DELIVERED", customerDetails[1][1] , customerDetails[1][2] },
                                      {"37288933", "DELIVERED", customerDetails[0][1] , customerDetails[0][2] },

                                      {"32832646", "DELIVERED", customerDetails[10][1] , customerDetails[10][2] },
                                      {"31884722", "TRANSIT", customerDetails[7][1] , customerDetails[7][2] },
                                      {"31994821", "TRANSIT", customerDetails[0][1] , customerDetails[0][2] },
                                      {"32994822", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"32561287", "TRANSIT", customerDetails[7][1] , customerDetails[7][2] },
                                      {"42884774", "DELIVERED", customerDetails[10][1] , customerDetails[10][2] },
                                      {"43277843", "DELIVERED", customerDetails[11][1] , customerDetails[11][2] },
                                      {"42997722", "DELIVERED", customerDetails[1][1] , customerDetails[1][2] },
                                      {"46727722", "DELIVERED", customerDetails[0][1] , customerDetails[0][2] },
                                      {"42276933", "DELIVERED", customerDetails[9][1] , customerDetails[9][2] },

                                      {"41083622", "TRANSIT", customerDetails[3][1] , customerDetails[3][2] },
                                      {"41857372", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"40353783", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"50090225", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"52882912", "TRANSIT", customerDetails[0][1] , customerDetails[0][2] },
                                      {"53882244", "TRANSIT", customerDetails[3][1] , customerDetails[3][2] },
                                      {"52657382", "DELIVERED", customerDetails[1][1] , customerDetails[1][2] },
                                      {"52513443", "TRANSIT", customerDetails[0][1] , customerDetails[0][2] },
                                      {"53288229", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"53729714", "TRANSIT", customerDetails[3][1] , customerDetails[3][2] },

                                      {"52789422", "DELIVERED", customerDetails[0][1] , customerDetails[0][2] },
                                      {"52882742", "TRANSIT", customerDetails[2][1] , customerDetails[2][2] },
                                      {"55299333", "TRANSIT", customerDetails[9][1] , customerDetails[9][2] },
                                      {"56729902", "TRANSIT", customerDetails[5][1] , customerDetails[5][2] },
                                      {"51043882", "TRANSIT", customerDetails[4][1] , customerDetails[4][2] },
                                      {"52787953", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"57920822", "DELIVERED", customerDetails[8][1] , customerDetails[8][2] },
                                      {"57028837", "DELIVERED", customerDetails[10][1] , customerDetails[10][2] },
                                      {"59028822", "DELIVERED", customerDetails[11][1] , customerDetails[11][2] },
                                      {"60001575", "TRANSIT", customerDetails[11][1] , customerDetails[11][2] },

                                      {"62178393", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"63929883", "TRANSIT", customerDetails[8][1] , customerDetails[8][2] },
                                      {"63490203", "TRANSIT", customerDetails[1][1] , customerDetails[1][2] },
                                      {"62599339", "TRANSIT", customerDetails[7][1] , customerDetails[7][2] },
                                      {"62134876", "TRANSIT", customerDetails[11][1] , customerDetails[11][2] },
                                      {"63453021", "TRANSIT", customerDetails[7][1] , customerDetails[7][2] },
                                      {"64299483", "TRANSIT", customerDetails[7][1] , customerDetails[7][2] },
                                      {"64529484", "TRANSIT", customerDetails[9][1] , customerDetails[9][2] },
                                      {"62994833", "TRANSIT", customerDetails[5][1] , customerDetails[5][2] },
                                      {"66729938", "DELIVERED", customerDetails[4][1] , customerDetails[4][2] },

                                      {"66290488", "TRANSIT", customerDetails[8][1] , customerDetails[8][2] },
                                      {"65729948", "DELIVERED", customerDetails[3][1] , customerDetails[3][2] },
                                      {"67983003", "TRANSIT", customerDetails[11][1] , customerDetails[11][2] },
                                      {"70000000", "TRANSIT", customerDetails[8][1] , customerDetails[8][2] },
                                      {"68120039", "TRANSIT", customerDetails[3][1] , customerDetails[3][2] }

                                      };

    private static String routingDetails [][] = {
                                      //trackingId, status, place, date
                                      {"17257332", "PICKUP", "San Francisco", "Jan 2"},

                                      {"19987333", "PICKUP", "San Francisco", "Jan 3"},
                                      {"19987333", "TRANSIT", "Nashville", "Jan 3"},
                                      {"19987333", "TRANSIT", "New York", "Jan 4"},
                                      {"19987333", "DELIVERED", "Mt. Kisco", "Jan 4"},

                                      {"18678334", "PICKUP", "San Francisco", "Jan 6"},
                                      {"18678334", "TRANSIT", "Nashville", "Jan 7"},
                                      {"18678334", "TRANSIT", "New York", "Jan 8"},
                                      {"19678334", "DELIVERED", "Mt. Kisco", "Jan 8"},

                                      {"18277893", "PICKUP", "San Francisco", "Jan 8" },
                                      {"18277893", "TRANSIT", "Dallas", "Jan 8" },
                                      {"18277893", "DELIVERED", "Amarillo", "Jan 8" },

                                      {"16892883", "PICKUP", "San Francisco", "Jan 10" },
                                      {"16892883", "TRANSIT", "Nashville", "Jan 10" },
                                      {"16892883", "DELIVERED", "Buffalo", "Jan 11" },

                                      {"15787333", "PICKUP", "San Francisco", "Jan 15" },
                                      {"15787333", "TRANSIT", "Nashville", "Jan 15" },
                                      {"15787333", "DELIVERED", "New York", "Jan 16" },


                                      {"18277333", "PICKUP", "San Francisco", "Feb 5"},
                                      {"18277333", "TRANSIT", "Nashville", "Feb 6"},


                                      {"22893727", "PICKUP", "San Francisco", "Feb 10" },
                                      {"22893727", "TRANSIT", "Nashville", "Feb 10" },

                                      {"18399487", "PICKUP", "San Francisco", "Feb 12"},
                                      {"18399487", "TRANSIT", "Nashville", "Feb 12"},
                                      {"18399487", "DELIVERED", "Pittsburgh", "Feb 13"},

                                      {"21948882", "PICKUP", "San Francisco", "Feb 15"},
                                      {"21948882", "TRANSIT", "Nashville", "Feb 16"},
                                      {"21948882", "DELIVERED", "Raleigh", "Feb 17"},


                                      {"19377832", "PICKUP", "San Francisco", "Feb 20" },
                                      {"19377832", "TRANSIT", "Nashville", "Feb 20" },


                                      {"20039882", "PICKUP", "San Francisco", "Feb 20" },
                                      {"20039882", "TRANSIT", "Nashville", "Feb 20" },

                                      {"20199727", "PICKUP", "San Francisco", "Feb 22" },

                                      {"21354220", "PICKUP", "San Francisco", "Feb 23" },


                                      {"28489292", "PICKUP", "San Francisco", "Mar 2" },
                                      {"28489292", "TRANSIT", "Nashville", "Mar 2" },

                                      {"23217832", "PICKUP", "San Francisco", "Mar 2" },

                                      {"23788288", "PICKUP", "San Francisco", "Mar 10" },
                                      {"23788288", "TRANSIT", "Nashville", "Mar 10" },
                                      {"23788288", "TRANSIT", "New York", "Mar 11" },
                                      {"23788288", "DELIVERED", "Mt. Kisco", "Mar 12" },

                                      {"23789993", "PICKUP", "San Francisco", "Mar 17" },
                                      {"23789993", "TRANSIT", "Nashville", "Mar 18" },
                                      {"23789993", "DELIVERED", "Pittsburgh", "Mar 19" },


                                      {"28789933", "PICKUP", "San Francisco", "Apr 3" },
                                      {"28789933", "TRANSIT", "Nashville", "Apr 3" },
                                      {"28789933", "DELIVERED", "Atlanta", "Apr 4" },

                                      {"37288933", "PICKUP", "San Francisco", "Apr 5" },
                                      {"37288933", "TRANSIT", "Nashville", "Apr 6" },
                                      {"37288933", "DELIVERED", "Pittsburgh", "Apr 7" },

                                      {"32832646", "PICKUP", "San Francisco", "Apr 10" },
                                      {"32832646", "TRANSIT", "Nashville", "Apr 11" },
                                      {"32832646", "DELIVERED", "Buffalo", "Apr 12" },

                                      {"31884722", "PICKUP", "San Francisco", "Apr 15" },
                                      {"31884722", "TRANSIT", "Nashville", "Apr 15" },
                                      {"31884722", "TRANSIT", "New York", "Apr 16" },

                                      {"31994821", "PICKUP", "San Francisco", "May 7" },
                                      {"31994821", "TRANSIT", "Nashville", "May 7" },

                                      {"32994822", "PICKUP", "San Francisco", "May 14" },
                                      {"32994822", "TRANSIT", "Nashville", "May 15" },

                                      {"32561287", "PICKUP", "San Francisco", "Apr 20" },

                                      {"42884774", "PICKUP", "San Francisco", "May 20" },
                                      {"42884774", "TRANSIT", "Nashville", "May 20" },
                                      {"42884774", "TRANSIT", "New York", "May 21" },
                                      {"42884774", "DELIVERED", "Buffalo", "May 22" },

                                      {"43277843", "PICKUP", "San Francisco", "May 25" },
                                      {"43277843", "TRANSIT", "Nashville", "May 25" },
                                      {"43277843", "TRANSIT", "Raleigh", "May 26" },
                                      {"43277843", "DELIVERED", "Chapel Hill", "May 26" },


                                      {"42997722", "PICKUP", "San Francisco", "Jun 5" },
                                      {"42997722", "TRANSIT", "Nashville", "Jun 6" },
                                      {"42997722", "DELIVERED", "Atlanta", "Jun 7" },


                                      {"46727722", "PICKUP", "San Francisco", "Jun 10" },
                                      {"46727722", "TRANSIT", "Nashville", "Jun 11" },
                                      {"46727722", "DELIVERED", "Pittsburgh", "Jun 11" },

                                      {"42276933", "PICKUP", "San Francisco", "Jun 15" },
                                      {"42276933", "TRANSIT", "Dallas", "Jun 15" },
                                      {"42276933", "DELIVERED", "Amarillo", "Jun 15" },


                                      {"41083622", "PICKUP", "San Francisco", "Jun 15" },
                                      {"41083622", "TRANSIT", "Nashville", "Jun 15" },

                                      {"41857372", "PICKUP", "San Francisco", "Jul 5" },
                                      {"41857372", "TRANSIT", "Nashville", "Jul 5" },

                                      {"40353783", "PICKUP", "San Francisco", "Jun 20" },

                                      {"50090225", "PICKUP", "San Francisco", "Jul 3" },
                                      {"50090225", "TRANSIT", "Nashville", "Jul 3" },

                                      {"52882912", "PICKUP", "San Francisco", "Jul 10" },
                                      {"52882912", "TRANSIT", "Nashville", "Jul 10" },

                                      {"53882244", "PICKUP", "San Francisco", "Jul 19" },
                                      {"53882244", "TRANSIT", "Nashville", "Jul 20" },

                                      {"52657382", "PICKUP", "San Francisco", "Aug 5" },
                                      {"52657382", "TRANSIT", "Nashville", "Aug 6" },
                                      {"52657382", "DELIVERED", "Atlanta", "Aug 7" },


                                      {"52513443", "PICKUP", "San Francisco", "Sep 5" },

                                      {"53288229", "PICKUP", "San Francisco", "Sep 10" },
                                      {"53288229", "TRANSIT", "Nashville", "Sep 12" },

                                      {"53729714", "PICKUP", "San Francisco", "Aug 20" },


                                      {"52789422", "PICKUP", "San Francisco", "Sep 13" },
                                      {"52789422", "TRANSIT", "Nashville", "Sep 13" },
                                      {"52789422", "DELIVERED", "Pittsburgh", "Sep 13" },

                                      {"52882742", "PICKUP", "San Francisco", "Sep 15" },
                                      {"52882742", "TRANSIT", "Nashville", "Sep 16" },

                                      {"55299333", "PICKUP", "San Francisco", "Sep 20" },
                                      {"55299333", "TRANSIT", "Nashville", "Sep 20" },
                                      {"55299333", "TRANSIT", "Dallas", "Sep 20" },

                                      {"56729902", "PICKUP", "San Francisco", "Sep 29" },
                                      {"56729902", "TRANSIT", "Nashville", "Sep 29" },

                                      {"51043882", "PICKUP", "San Francisco", "Sep 29" },
                                      {"51043882", "TRANSIT", "Nashville", "Sep 29" },
                                      {"51043882", "TRANSIT", "Baltimore", "Sep 29" },

                                      {"52787953", "PICKUP", "San Francisco", "Oct 3" },
                                      {"52787953", "TRANSIT", "Nashville", "Oct 4" },

                                      {"57920822", "PICKUP", "San Francisco", "Oct 8" },
                                      {"57920822", "TRANSIT", "Nashville", "Oct 9" },
                                      {"57920822", "TRANSIT", "Baltimore", "Oct 9" },
                                      {"57920822", "DELIVERED", "Grand Lake", "Oct 10" },

                                      {"57028837", "PICKUP", "San Francisco", "Oct 14" },
                                      {"57028837", "TRANSIT", "Nashville", "Oct 14" },
                                      {"57028837", "DELIVERED", "Buffalo", "Oct 15" },

                                      {"59028822", "PICKUP", "San Francisco", "Oct 19" },
                                      {"59028822", "TRANSIT", "Nashville", "Oct 20" },
                                      {"59028822", "DELIVERED", "Atlanta", "Oct 20" },

                                      {"60001575", "PICKUP", "San Francisco", "Oct 23" },


                                      {"62178393", "PICKUP", "San Francisco", "Nov 4" },
                                      {"62178393", "TRANSIT", "Nashville", "Nov 4" },
				      
                                      {"63929883", "PICKUP", "San Francisco", "Nov 10" },
                                      {"63929883", "TRANSIT", "Nashville", "Nov 10" },

                                      {"63490203", "PICKUP", "San Francisco", "Dec 3" },
                                      {"63490203", "TRANSIT", "Nashville", "Dec 4" },

                                      {"62599339", "PICKUP", "San Francisco", "Dec 9" },
                                      {"62599339", "TRANSIT", "Nashville", "Dec 9" },

                                      {"62134876", "PICKUP", "San Francisco", "Nov 2" },

                                      {"63453021", "PICKUP", "San Francisco", "Dec 2" },

                                      {"64299483", "PICKUP", "San Francisco", "Dec 13" },
                                      {"64299483", "TRANSIT", "Nashville", "Dec 15" },

                                      {"64529484", "PICKUP", "San Francisco", "Dec 15" },
                                      {"64529484", "TRANSIT", "Nashville", "Dec 15" },


                                      {"62994833", "PICKUP", "San Francisco", "Dec 16" },
                                      {"62994833", "TRANSIT", "Nashville", "Dec 16" },

                                      {"66729938", "PICKUP", "San Francisco", "Dec 16" },
                                      {"66729938", "TRANSIT", "Nashville", "Dec 17" },
                                      {"66729938", "TRANSIT", "Baltimore", "Dec 17" },
                                      {"66729938", "DELIVERED", "Fairfax", "Dec 18" },


                                      {"66290488", "PICKUP", "San Francisco", "Dec 20" },
                                      {"66290488", "TRANSIT", "Nashville", "Dec 20" },

                                      {"65729948", "PICKUP", "San Francisco", "Dec 20" },
                                      {"65729948", "TRANSIT", "Nashville", "Dec 21" },
                                      {"65729948", "DELIVERED", "Raleigh", "Dec 22" },

                                      {"67983003", "PICKUP", "San Francisco", "Dec 21" },
                                      {"67983003", "TRANSIT", "Nashville", "Dec 22" },
                                      {"67983003", "TRANSIT", "Raleigh", "Dec 22" },

                                      {"68120039", "PICKUP", "San Francisco", "Dec 27" },
                                      {"68120039", "TRANSIT", "Nashville", "Dec 28" }

                                      };

    private static HashMap routingDetailsMap = new HashMap();
    private static int numRouting = 152;
                                      
    private static HashMap trackingDetailsMap = new HashMap();
    private static int numTracking = 65;
    private static String accountDetails [][] = {
                                           //orderId, value, outstanding balance
                                           { "012001000000", "$400,500", "$40,500"},
                                           { "012001000001", "$100,500", "$0"},
                                           { "012001000002", "$1,000,000", "$0"},
                                           { "012001000003", "$200,500", "$0"},
                                           { "012001000004", "$300,500", "$0"},
                                           { "012001000005", "$10,500", "$5,000"},
                                           { "022001000011", "$100,500", "$10,000"},
                                           { "022001000012", "$505,700", "$505,700"},
                                           { "022001000013", "$1,095,000", "$0"},
                                           { "022001000014", "$901,000", "$0"},
                                           { "022001000015", "$585,005", "$585,005"},
                                           { "022001000016", "$5,320,100", "$4,000,000"},
                                           { "022001000017", "$1,200,405", "$0"},
                                           { "022001000018", "$20,005", "$0"},
                                           { "032001000000", "$20,005", "$20,005"},
                                           { "032001000001", "$200,405", "$200,405"},
                                           { "032001000002", "$50,495", "$0"},
                                           { "032001000003", "$534,695", "$100,500"},
                                           { "042001000001", "$584,095", "$0"},
                                           { "042001000002", "$554,005", "$0"},
                                           { "042001000003", "$1,434,695", "$0"},
                                           { "042001000004", "$134,795", "$134,795"},
                                           { "042001000005", "$34,705", "$34,705"},
                                           { "052001000000", "$4,095", "$0"},
                                           { "052001000001", "$1,133,795", "$0"},
                                           { "052001000002", "$185,095", "$0"},
                                           { "052001000003", "$104,005", "50,000"},
                                           { "062001000001", "$64,005", "$0"},
                                           { "062001000002", "$204,005", "$204,005"},
                                           { "062001000003", "$204,000", "$0"},
                                           { "062001000004", "$104,000", "$104,000"},
                                           { "062001000005", "$44,000", "$44,000"},
                                           { "072001000000", "$95,000", "$8,000"},
                                           { "072001000001", "$195,000", "$7,000"},
                                           { "072001000002", "$100,000", "$60,000"},
                                           { "072001000003", "$224,000", "$0"},
                                           { "082001000001", "$224,000", "$0"},
                                           { "082001000002", "$64,000", "$0"},
                                           { "092001000000", "$34,000", "$13,500"},
                                           { "092001000001", "$324,000", "$103,550"},
                                           { "092001000002", "$554,000", "$0"},
                                           { "092001000003", "$325,005", "$325,005"},
                                           { "092001000004", "$24,000", "$1,000"},
                                           { "092001000005", "$4,000", "$0"},
                                           { "092001000006", "$624,000", "$0"},
                                           { "102001000001", "$922,005", "$700,000"},
                                           { "102001000002", "$724,000", "$0"},
                                           { "102001000003", "$66,000", "$0"},
                                           { "102001000004", "$25,000", "$25,000"},
                                           { "102001000005", "$85,000", "$85,000"},
                                           { "112001000000", "$50,000", "$0"},
                                           { "112001000001", "$5,000", "$0"},
                                           { "112001000002", "$5,900", "$900"},
                                           { "122001000000", "$90,000", "$0"},
                                           { "122001000001", "$90,900", "$0"},
                                           { "122001000002", "$1,999,900", "$633,100"},
                                           { "122001000003", "$1,000,900", "$245,000"},
                                           { "122001000004", "$88,900", "$88,900"},
                                           { "122001000005", "$999,900", "$0"},
                                           { "122001000006", "$5,000,900", "$0"},
                                           { "122001000007", "$500,900", "$399,100"},
                                           { "122001000008", "$40,900", "$0"},
                                           { "122001000009", "$135,900", "$0"},
                                           { "122001000010", "$2,005,900", "$0"},
                                           { "122001000011", "$1,000,000", "$1,000,000"},
                                      };

    private static HashMap accountDetailsMap = new HashMap();
    private static int numAccounts = numTracking;
    private static HashMap orderDetailsMap = new HashMap();
    private static int numOrders = numTracking;




    static {
        //Build in-memory structures for shipping data in static initializer 
	for (int month=0; month < months.length; month++) {
	    Order orders[] = new Order[numMonthlyOrders[month]];
	    for (int i = 0; i < numMonthlyOrders[month]; i++)
	        orders[i] = new Order(monthlyOrders[month][i][0], monthlyOrders[month][i][1], monthlyOrders[month][i][2]);
            monthlyOrdersMap.put(months[month], orders);
	}
	for (int order=0; order < numOrders; order++) {
	    OrderDetail od = new OrderDetail(orderDetails[order][0], orderDetails[order][1], orderDetails[order][2], orderDetails[order][3], orderDetails[order][4]);
	    orderDetailsMap.put(orderDetails[order][0], od);
	}
	for (int customer=0; customer < numCustomers; customer++) {
	    CustomerDetail cd = new CustomerDetail(customerDetails[customer][0], customerDetails[customer][1], customerDetails[customer][2], customerDetails[customer][3]);
	    customerDetailsMap.put(customerDetails[customer][0], cd);
	    customerDetailsByNameMap.put(customerDetails[customer][1], cd);
	}
	for (int routing=0; routing < numRouting; routing++) {
	    ArrayList rdal = (ArrayList) routingDetailsMap.get(routingDetails[routing][0]);
	    if (rdal == null) {
	        rdal = new ArrayList();
	    }
	    RouteSegment rs = new RouteSegment(routingDetails[routing][0], routingDetails[routing][1], routingDetails[routing][2], routingDetails[routing][3]);
	    rdal.add(rs);
	    routingDetailsMap.put(routingDetails[routing][0], rdal);
	}
	for (int tracking=0; tracking < numTracking; tracking++) {
	    TrackingDetail td = new TrackingDetail(trackingDetails[tracking][0], trackingDetails[tracking][1], 
	                                           trackingDetails[tracking][2], trackingDetails[tracking][3], 
						   getRouteSegments(trackingDetails[tracking][0]));
	    trackingDetailsMap.put(trackingDetails[tracking][0], td);
	}
	for (int account=0; account < numAccounts; account++) {
	    AccountDetail ad = new AccountDetail(accountDetails[account][0], accountDetails[account][1], accountDetails[account][2]);
	    accountDetailsMap.put(accountDetails[account][0], ad);
	}
    }

    public static OrderDetail getOrderDetail(String orderId) {
	orderId = orderId.trim();
        return (OrderDetail) orderDetailsMap.get(orderId);
    }

    public static Order[] getOrders(String month) {
        String key = normalizeMonth(month);
	return (Order[]) monthlyOrdersMap.get(key);
    }

    public static CustomerDetail getCustomerDetail (String customerId) {
	customerId = customerId.trim();
         return (CustomerDetail) customerDetailsMap.get(customerId);
    }

    public static CustomerDetail getCustomerDetailByName (String customerName) {
	customerName = customerName.trim();
         return (CustomerDetail) customerDetailsByNameMap.get(customerName);
    }

    public static TrackingDetail getTrackingDetail(String trackingId) {
	trackingId = trackingId.trim();
         return (TrackingDetail) trackingDetailsMap.get(trackingId);
    }

    //Supports trackingDetail; returns the route segments associated with 
    //the tracking id.
    private static RouteSegment[] getRouteSegments(String trackingId) {
	trackingId = trackingId.trim();
	RouteSegment[] routeSegments = null;
	ArrayList routeSegmentsAL = (ArrayList) routingDetailsMap.get(trackingId);
	if (routeSegmentsAL != null)
	    routeSegments = (RouteSegment[]) routeSegmentsAL.toArray(new RouteSegment[0]);
        return routeSegments;
    }

    public static AccountDetail getAccountDetail(String accountId) {
	accountId = accountId.trim();
         return (AccountDetail) accountDetailsMap.get(accountId);
    }

    public static String normalizeMonth(String month) {
        if (month == null) return null;
	month = month.trim().toLowerCase();
	if (month.length() > 3) {
	    month = month.substring(0, 3);
	}
        if (month.equalsIgnoreCase("jan") || month.equalsIgnoreCase("january"))
	    return JANUARY;    
	else if (month.equalsIgnoreCase("feb") || month.equalsIgnoreCase("february"))
	    return FEBRUARY;
	else if (month.equalsIgnoreCase("mar") || month.equalsIgnoreCase("march"))
	    return MARCH;
	else if (month.equalsIgnoreCase("apr") || month.equalsIgnoreCase("april"))
	    return APRIL;
	else if (month.equalsIgnoreCase("may"))
	    return MAY;
	else if (month.equalsIgnoreCase("jun") || month.equalsIgnoreCase("june"))
	    return JUNE;
	else if (month.equalsIgnoreCase("jul") || month.equalsIgnoreCase("july"))
	    return JULY;
	else if (month.equalsIgnoreCase("aug") || month.equalsIgnoreCase("august"))
	    return AUGUST;
	else if (month.equalsIgnoreCase("sep") || month.equalsIgnoreCase("september"))
	    return SEPTEMBER;
	else if (month.equalsIgnoreCase("oct") || month.equalsIgnoreCase("october"))
	    return OCTOBER;
	else if (month.equalsIgnoreCase("nov") || month.equalsIgnoreCase("november"))
	    return NOVEMBER;
	else if (month.equalsIgnoreCase("dec") || month.equalsIgnoreCase("december"))
	    return DECEMBER;

        return null;
    }

    public static void main(String args[]) {

        //Test driver 
	dump();

    }

    public static void dump() {
        bigSeparator();
	System.out.println("PRINTING MONTHLY ORDERS");

        Order[] orders;
	for (int i = 0; i < months.length; i++) {
	    orders = getOrders(months[i]);
	    dumpOrders(months[i], orders);
	}

        bigSeparator();
	System.out.println("PRINTING ORDER DETAILS");

        Iterator it = orderDetailsMap.values().iterator();

	while (it.hasNext()) {
	    ((Dumpable) it.next()).dump();
	}
        
        bigSeparator();
	System.out.println("PRINTING CUSTOMER DETAILS");

        it = customerDetailsMap.values().iterator();

	while (it.hasNext()) {
	    ((Dumpable) it.next()).dump();
	}
        
        bigSeparator();
	System.out.println("PRINTING TRACKING DETAILS");

        it = trackingDetailsMap.values().iterator();

	while (it.hasNext()) {
	    ((Dumpable) it.next()).dump();
	}
        
        bigSeparator();
	System.out.println("PRINTING ACCOUNT DETAILS");

        it = accountDetailsMap.values().iterator();

	while (it.hasNext()) {
	    ((Dumpable) it.next()).dump();
	}
        
    }

    private static void dumpOrders(String month, Order[] orders) {
        mediumSeparator();
        System.out.println("Orders for " + month);
	for (int i = 0; i < orders.length; i++) {
	    orders[i].dump();
	    smallSeparator();
        }
    }

    private static void bigSeparator() {
        System.out.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
    }

    private static void mediumSeparator() {
        System.out.println("************************************");
    }

    private static void smallSeparator() {
        System.out.println("--------------------");
    }

}
