/* @copyright module */
/*                                                                            */
/*  DISCLAIMER OF WARRANTIES:                                                 */
/*  -------------------------                                                 */
/*  The following [enclosed] code is sample code created by IBM Corporation.  */
/*  This sample code is provided to you solely for the purpose of assisting   */
/*  you in the development of your applications.                              */
/*  The code is provided "AS IS", without warranty of any kind. IBM shall     */
/*  not be liable for any damages arising out of your use of the sample code, */
/*  even if they have been advised of the possibility of such damages.        */
package com.ibm.etools.portal.portletexamples.cooperative.jsr;

import javax.portlet.PortletRequest;
import javax.portlet.PortletResponse;
import javax.portlet.PortletSession;
import javax.portlet.PortletURL;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
public class ShippingUtils {
    private static final String SHIPPING_PREFIX = "SHIPPING";
    private static final String LAST_MODIFIED = SHIPPING_PREFIX + "lastModified";
    public static final String NAMESPACE = "http://www.ibm.com/wps/c2a/examples/shipping";
    public static final String ACTION_NAME_PARAM = "ACTION_NAME";
	private static final String JSP_FOLDER = "/jsp/"; // JSP folder name //$NON-NLS-1$

    public static String createActionURI(String actionName, PortletResponse response) {
        return new String();  //TODO
 /*           DefaultPortletAction ordersForMonthAction = new DefaultPortletAction(actionName);
	    PortletURI portletURI = response.createReturnURI();
	    portletURI.addAction(ordersForMonthAction);
	    String actionURI = portletURI.toString();
	    return actionURI;
 */           
    }

    public static PortletURL createSimpleActionURL(String actionName, RenderResponse response) {
		PortletURL portletURL = response.createActionURL();
		portletURL.setParameter(ACTION_NAME_PARAM, actionName);
		return portletURL;
    }
    public static void setLastModified(PortletRequest request) {
        PortletSession session = request.getPortletSession();
	session.setAttribute(LAST_MODIFIED, new Long(System.currentTimeMillis()));
    }

    public static long getLastModified(PortletRequest request) {
        PortletSession session = request.getPortletSession();
	Long lastModified = (Long) session.getAttribute(LAST_MODIFIED);
	return (lastModified == null) ? -1 : lastModified.longValue();
    }

	/**
	 * Returns JSP file path.
	 * 
	 * @param request Render request
	 * @param jspFile JSP file name
	 * @return JSP file path
	 */
	public static String getJspFilePath(RenderRequest request, String jspFile) {
		String markup = request.getProperty("wps.markup"); //$NON-NLS-1$
		if( markup == null )
			markup = getMarkup(request.getResponseContentType());
		return JSP_FOLDER+markup+"/"+jspFile; //$NON-NLS-1$
}
	/**
	 * Convert MIME type to markup name.
	 * 
	 * @param contentType MIME type
	 * @return Markup name
	 */
	private static String getMarkup(String contentType) {
		if( "text/vnd.wap.wml".equals(contentType) ) //$NON-NLS-1$
			return "wml"; //$NON-NLS-1$
		return "html"; //$NON-NLS-1$
	}
}
