
// This global variable serves as a flag for RTE acessibility support.
// This var is set in options_ie.jsp when the accessible toolbar is invoked.
var isAccessible = false;

function IBM_RTE_isMozilla() {
    return navigator.product == 'Gecko';
}

function IBM_RTE_getFrame(editorName) {
    if (!isAccessible)
       return document.getElementById(editorName + "docView");
    else
       return this.opener.document.getElementById(editorName + "docView");      
}

function IBM_RTE_getWindow(editorName) {
    return IBM_RTE_getFrame(editorName).contentWindow;
}

function IBM_RTE_getDocument(editorName) {
    return IBM_RTE_getWindow(editorName).document;
}

function IBM_RTE_setDesignMode(editorName) {
    IBM_RTE_getDocument(editorName).designMode = "on";  

}

function IBM_RTE_getToolbarColor(editorName) {
    return IBM_RTE_isMozilla() ? document.defaultView.getComputedStyle(document.getElementById(editorName), '').getPropertyValue("background-color") : document.getElementById(editorName).currentStyle.backgroundColor;
}

function IBM_RTE_loadEditorWithEmptyDocument(editorName, docDir) {
    IBM_RTE_getDocument(editorName).body.innerHTML = "<html><head><title></title></head><body dir='" + docDir + "'></body></html>";
}

function IBM_RTE_doTheCommand(editorName, commandname) {        
    IBM_RTE_getWindow(editorName).focus();
    IBM_RTE_getDocument(editorName).execCommand(commandname, false, null);
}

function IBM_RTE_doLink(editorName, prompttext) {    
    if (IBM_RTE_isMozilla()) {
        var theurl = prompt(prompttext, "http://");
        IBM_RTE_getDocument(editorName).execCommand('createlink', false, theurl);
    }
    else {
        IBM_RTE_getWindow(editorName).focus();
        IBM_RTE_getDocument(editorName).execCommand('createlink', true, null);
    }
}

function IBM_RTE_doFontStyle(editorName, ctrl, commandname) {
    
    if (ctrl) {
        var hType = ctrl.options[ctrl.selectedIndex].value;

        if (!isAccessible)
            ctrl.selectedIndex = 0;

        if (hType != '') {
            IBM_RTE_getWindow(editorName).focus();
            IBM_RTE_getDocument(editorName).execCommand(commandname, false, hType);
    }}
}

function IBM_RTE_doPrint(editorName) {

    IBM_RTE_getWindow(editorName).focus();
    IBM_RTE_getWindow(editorName).print();
}

function IBM_RTE_getOffsetTop(ctrl) {

    var offsetTop = ctrl.offsetTop;
    var offsetParent = ctrl.offsetParent;

    while (offsetParent) {            
        offsetTop += offsetParent.offsetTop;
        offsetParent = offsetParent.offsetParent;
    }

    return offsetTop;
}

function IBM_RTE_getOffsetLeft(ctrl) {

    var offsetLeft = ctrl.offsetLeft;
    var offsetParent = ctrl.offsetParent;

    while (offsetParent) {
        offsetLeft += offsetParent.offsetLeft;
        offsetParent = offsetParent.offsetParent;
    }

    return offsetLeft;
}

function IBM_RTE_doColor(editorName, clrType, buttonElement, locale, images, directory, isBidi) {

    if (IBM_RTE_isMozilla()) {
        if (clrType.localeCompare("backcolor") == 0) 
             clrType = "hilitecolor"; 
    }

    document.getElementById(editorName + "_color").value = clrType;
    var jrl = "colors_ie.jsp";
    jrl = directory + jrl;
    //var wcp_colorWin = window.open(jrl + '?locale=' + locale + '&images=' + images + '&editorName=' + editorName + '&isBidi=' + isBidi, 'colors', 'scrollbars=0, toolbar=0, statusbar=0, width=260, height=170, left=' + IBM_RTE_getOffsetLeft(buttonElement) + ', top=' + (IBM_RTE_getOffsetTop(buttonElement) + 100));
    var wcp_colorWin = window.open(jrl + '?locale=' + locale + '&images=' + images + '&editorName=' + editorName + '&isBidi=' + isBidi, 'colors', 'scrollbars=0, toolbar=0, statusbar=0, width=260, height=150, left=' + ((screen.width - 260) / 2) + ', top=' + ((screen.height - 150) / 2));
    wcp_colorWin.focus();
}



// Used to insert elements in Mozilla editor.
function IBM_RTE_insertNodeAtSelection(win, insertNode) {
  
    // get current selection
    var sel = win.getSelection();

    // get the first range of the selection
    // (there's almost always only one range)
    var range = sel.getRangeAt(0);

    // deselect everything
    sel.removeAllRanges();

    // remove content of current selection from document
    range.deleteContents();

    // get location of current selection
    var container = range.startContainer;
    var pos = range.startOffset;

    // make a new range for the new selection
    range = document.createRange();

    if (container.nodeType == 3 && insertNode.nodeType == 3) {
    
        // if we insert text in a textnode, do optimized insertion
        container.insertData(pos, insertNode.nodeValue);
        
        // put cursor after inserted text
        range.setEnd(container, pos + insertNode.length);
        range.setStart(container, pos + insertNode.length);        
    }
    else {
        
        var afterNode;
        if (container.nodeType == 3) {

            // when inserting into a textnode
            // we create 2 new textnodes
            // and put the insertNode in between

            var textNode = container;
            container = textNode.parentNode;
            var text = textNode.nodeValue;

            // text before the split
            var textBefore = text.substr(0,pos);
            // text after the split
            var textAfter = text.substr(pos);
            
            var beforeNode = document.createTextNode(textBefore);
            var afterNode = document.createTextNode(textAfter);
            
            // insert the 3 new nodes before the old one
            container.insertBefore(afterNode, textNode);
            container.insertBefore(insertNode, afterNode);
            container.insertBefore(beforeNode, insertNode);
            
            // remove the old node
            container.removeChild(textNode);
        }
        else {

            // else simply insert the node
            afterNode = container.childNodes[pos];
            container.insertBefore(insertNode, afterNode);
        }

        range.setEnd(afterNode, 0);
        range.setStart(afterNode, 0);
    }

    sel.addRange(range);
}

function IBM_RTE_doTableInsert(editorName, buttonElement, locale, images, directory, numrows, numcols, isBidi) {

    IBM_RTE_getWindow(editorName).focus();
    var wcp_tableWin = window.open(directory + 'table_ie.jsp?locale=' + locale + '&images=' + images + '&editorName=' + editorName + '&isBidi=' + isBidi, 'table', 'scrollbars=0, toolbar=0, statusbar=0, width=200, height=170, left=' + ((screen.width - 200) / 2) + ', top=' + ((screen.height - 170) / 2));
    wcp_tableWin.focus();
}

function IBM_RTE_getEditorHTML(editorName) {

    var bodyDir =  IBM_RTE_getDocument(editorName).body.dir;

    var lnks = IBM_RTE_getDocument(editorName).getElementsByTagName("link");

    var iHead = '<html>\n<head>\n<meta http-equiv="content-type" content="text/html; charset=utf-8" />\n';
    var ttls = IBM_RTE_getDocument(editorName).getElementsByTagName("title");
    if ((ttls) && ttls.length > 0) {
        iHead += "<title>" + ttls[0].text + "</title>\n";
    }
    
    for (i = 0; (lnks) && (i < lnks.length); i++) {
        iHead += "<link rel='" + lnks[0].rel + "' href='" + lnks[i].href + "' />\n";
    }

    iHead += "</head>\n";

    if (bodyDir.localeCompare('ltr') == 0)
        iHead += "<body dir='ltr'>\n";
    else if (bodyDir.localeCompare('rtl') == 0) 
        iHead += "<body dir='rtl'>\n";
    else
        iHead += "<body>\n";

    iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
    iFoot = "</body>\n</html>";

    iAll = iHead + iHTML + iFoot;

    return iAll;
}


function IBM_RTE_getEditorHTML2(editorName, metaCnt) {

    var bodyDir =  IBM_RTE_getDocument(editorName).body.dir;

    var lnks = IBM_RTE_getDocument(editorName).getElementsByTagName("link");

    var iHead = '<html>\n<head>\n';
    iHead += '<meta http-equiv="content-type" content="' + metaCnt + '" />\n';

    var ttls = IBM_RTE_getDocument(editorName).getElementsByTagName("title");
    if ((ttls) && ttls.length > 0) {
        iHead += "<title>" + ttls[0].text + "</title>\n";
    }
    
    for (i = 0; (lnks) && (i < lnks.length); i++) {
        iHead += "<link rel='" + lnks[0].rel + "' href='" + lnks[i].href + "' />\n";
    }

    iHead += "</head>\n";

    if (bodyDir.localeCompare('ltr') == 0)
        iHead += "<body dir='ltr'>\n";
    else if (bodyDir.localeCompare('rtl') == 0) 
        iHead += "<body dir='rtl'>\n";
    else
        iHead += "<body>\n";

    iHTML = IBM_RTE_getDocument(editorName).body.innerHTML;
    iFoot = "</body>\n</html>";

    iAll = iHead + iHTML + iFoot;

    return iAll;
}

function IBM_RTE_getEditorHTMLFragment(editorName) {

    return IBM_RTE_getDocument(editorName).body.innerHTML;
}

function IBM_RTE_setEditorHTML(editorName, content) {

    IBM_RTE_getDocument(editorName).body.innerHTML = content;
}

function IBM_RTE_encodeHTML(str) {

	if (!str) return '';
	if (typeof(str) != 'string') str = str.toString();

	str = str.replace( /&/g, '&amp;' );
	str = str.replace( /</g, '&lt;' );
	str = str.replace( />/g, '&gt;' );
	str = str.replace( /"/g, '&quot;' );

	return str;
}

function IBM_RTE_flipDocument(editorName, prompttext) {

    var origDir =  IBM_RTE_getDocument(editorName).body.dir;

    if ((origDir.localeCompare('') == 0)||(origDir.localeCompare('ltr') == 0))
        IBM_RTE_getDocument(editorName).body.dir = "rtl";
    else if (origDir.localeCompare('rtl') == 0)
        IBM_RTE_getDocument(editorName).body.dir = "ltr";

    IBM_RTE_getWindow(editorName).focus();

}


function IBM_RTE_getSelectionRange(editorName)
{
      var doc = IBM_RTE_getDocument(editorName);
      var win = IBM_RTE_getWindow(editorName);

	var ret = null; 
	if(doc.selection)
		ret = doc.selection.createRange();
	else if (win.getSelection)
	{
		var sel = win.getSelection();
		if(sel != null && sel.rangeCount > 0)
			ret = sel.getRangeAt(0);
	}
	return ret;
}


// TODO: detect and clean up redundant DIR tags while preserving other tags.

// Mozilla has no good way to insert a new node to subsume the selection content 
// other than using surroundContents(). SurroundContents() is not very tolerant in
// the selection, such as if the Range partially selects a non-Text node, 
// surroundContents() raises an exception.
// Using separate operations extractContents(), insertNode() will NOT help, it would
// only make things worse, as when insertNode() throws exception, the range content 
// has been removed already. Using surroundContents(), when it throws exception, the 
// range content will remain unchanged.
//
// May need to find a way to mimic IE's behavior???

function IBM_RTE_flipSelection(editorName, prompttext, dir) {

    // Get a selection range.
    var rng = IBM_RTE_getSelectionRange(editorName);
    
    if (IBM_RTE_isMozilla()) {

        if (rng) {

            var doc = IBM_RTE_getDocument(editorName);
  
            var newParent = doc.createElement("div");
            newParent.setAttribute("dir", dir);

            rng.surroundContents(newParent);
        }
    }
    else {
        if (rng) {

            var newParent = IBM_RTE_getDocument(editorName).createElement("DIV DIR='" + dir + "'");
            newParent.innerHTML = rng.htmlText;
            rng.pasteHTML(newParent.outerHTML);
        }
    }

    IBM_RTE_getWindow(editorName).focus();
}


function IBM_RTE_checkEvent(editorName) {

   if (typeof checkEvent != 'undefined') {
       checkEvent();
    }
    
}


// These three functions are actually used in dialogs to highlight 
// buttons when mouse is moved over. Use document instead of 
// IBM_RTE_getDocument() because dialogs are in their own windows.
function setStyle(element, name, value) {
        if (element.style && (element.style[name] != value) )
            element.style[name] = value;
}

function IBM_RTE_btn_mouseover(id) {
        
        var elmt = document.getElementById(id);

        if (elmt) {
            setStyle(elmt, 'color', '#0000FF');
            setStyle(elmt, 'borderColor', '#0000FF');
        }
}

function IBM_RTE_btn_mouseoout(id) {
        
        var elmt = document.getElementById(id);

        if (elmt) {
            setStyle(elmt, 'color', '#405380');
            setStyle(elmt, 'borderColor', '#405380');
        }
}

